#include QMK_KEYBOARD_H
#include "wanleg.h"

#define _________________BLANK_75__________________ _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______
#define _________________BLANK_50__________________ _______, _______, _______, _______, _______, _______, _______, _______, _______, _______
#define _________________Num_Row_75________________ KC_ESC,  KC_1,    KC_2,    KC_3,    KC_4,    KC_5,    KC_6,    KC_7,    KC_8,    KC_9,    KC_0,    KC_NLCK

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
#if defined(KEYBOARD_5x5)
[GK75] = LAYOUT_ortho_5x15_wrapper(
  _________________Num_Row_75________________, QWERTY75, XXXXXXX, FUNCTION75,
  _______________GherkinLike_0_______________, KC_KP_7, KC_KP_8, KC_KP_9,
  _______________GherkinLike_1_______________, KC_KP_4, KC_KP_5, KC_KP_6,
  TD(TD_SFT_CAPS), SFT_T(KC_Z), KC_X, KC_C, LT(NUM75, KC_V), LT(ETC75, KC_B), KC_N, LT(DIR75, KC_M), GUI_T(KC_COMM), ALT_T(KC_DOT), CTL_T(KC_BSPC), SFT_T(KC_ENT), KC_KP_1, KC_KP_2, KC_KP_3,
  TD(RST_TAP_DANCE), GHERKIN50, KC_LALT, NUMPAD, NUMBER75, ETCETERA75, KC_SPC,DIRECTION75, KC_RGUI, KC_RALT, KC_DEL, KC_RCTL, KC_KP_0, KC_KP_0, KC_KP_DOT
),

[PAD] = LAYOUT_ortho_5x5_wrapper(
  _______, _______, _______, _______, _______,
  _______________NUMPAD_Row__0_______________, _______,
  _______________NUMPAD_Row__1_______________, _______,
  _______________NUMPAD_Row__2_______________, _______,
  KC_KP_0, TD(LYR50_TAP_DANCE), KC_KP_DOT, KC_PMNS, _______
),

[GK50] = LAYOUT_ortho_5x10_wrapper(
  KC_ESC,    _______, _______, _______, _______, _______, _______, _______, _______,    KC_BSPC,
  _______________Gherkin_Row_0_______________,
  _______________Gherkin_Row_1_______________,
  _______________Gherkin_Row_2_______________,
  TD(RST_TAP_DANCE), GHERKIN75, NUMPAD, gNUMBER, gETCETERA, KC_SPC,gDIRECTION, KC_RGUI, KC_RALT, KC_RGUI
),

#else
 /* Gherkin 75
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * | ESC    | 1      | 2      | 3      | 4      | 5      | 6      | 7      | 8      | 9      | 0      | NUMLOCK| qwerty |        | FN     |
 * |-----------------------------------------------------------------------------------------------------------+--------+--------+--------|
 * |                                                                                                           |   7    |   8    |   9    |
 * |                                                                                                           |--------+--------+--------|
 * |                                            4x12 GHERKIN LAYOUT                                            |   4    |   5    |   6    |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |   1    |   2    |   3    |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |   0    |   0    |   .    |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[GK75] = LAYOUT_ortho_5x15_wrapper(
  _________________Num_Row_75________________, QWERTY75, XXXXXXX, FUNCTION75,
  _______________GherkinLike_0_______________, KC_KP_7, KC_KP_8, KC_KP_9,
  _______________GherkinLike_1_______________, KC_KP_4, KC_KP_5, KC_KP_6,
  TD(TD_SFT_CAPS), SFT_T(KC_Z), KC_X, KC_C, LT(NUM75, KC_V), LT(ETC75, KC_B), KC_N, LT(DIR75, KC_M), GUI_T(KC_COMM), ALT_T(KC_DOT), CTL_T(KC_BSPC), SFT_T(KC_ENT), KC_KP_1, KC_KP_2, KC_KP_3,
  KC_LCTL, KC_LGUI, KC_LALT, KC_LALT, NUMBER75, ETCETERA75, KC_SPC,DIRECTION75, KC_RGUI, KC_RALT, KC_DEL, KC_RCTL, KC_KP_0, KC_KP_0, KC_KP_DOT
),
#endif
 /* QWERTY 75
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * | ESC    | 1      | 2      | 3      | 4      | 5      | 6      | 7      | 8      | 9      | 0      | NUMLOCK| gherkin|        | FN     |
 * |-----------------------------------------------------------------------------------------------------------+--------+--------+--------|
 * |                                                                                                           |   7    |   8    |   9    |
 * |                                                                                                           |--------+--------+--------|
 * |                                             4x12 QWERTY LAYOUT                                            |   4    |   5    |   6    |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |   1    |   2    |   3    |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |   0    |   0    |   .    |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[QW75] = LAYOUT_ortho_5x15_wrapper(
  _________________Num_Row_75________________, GHERKIN75, XXXXXXX, FUNCTION75,
  _______________Qwerty_Row__0_______________, KC_KP_7, KC_KP_8, KC_KP_9,
  _______________Qwerty_Row__1_______________, KC_KP_4, KC_KP_5, KC_KP_6,
  _______________Qwerty_Row__2_______________, KC_KP_1, KC_KP_2, KC_KP_3,
  KC_LCTL, KC_LGUI, KC_LALT, KC_LALT, SUBTER75, KC_LSFT, KC_SPC, SUPRA75, KC_RGUI, KC_RALT, KC_DEL, KC_RCTL, KC_KP_0, KC_KP_0, KC_KP_DOT
),

 /* SUBTER75
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * |                                            SUBTER ROW 0 LAYOUT                                            |        |        |        |
 * |-----------------------------------------------------------------------------------------------------------+--------+-----------------|
 * |                                                                                                           |   /    |   *    |   -    |
 * |                                                                                                           |--------+--------+--------|
 * |                                            4x12 SUBTER LAYOUT                                             |        |        |   +    |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        | ENTER  |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[SUB75] = LAYOUT_ortho_5x15_wrapper(
  _______________SUBTER_Row__0_______________, _______, _______, _______,
  _______________SUBTER_Row__0_______________, KC_PSLS, KC_PAST, KC_PMNS,
  _______________SUBTER_Row__1_______________, _______, _______, KC_PPLS,
  _______________SUBTER_Row__2_______________, _______, _______, KC_PENT,
  _______, _______, GHERKIN75, _______, _______, _______, KC_ENT, KC_LSFT, _______, _______,	_______,	_______, _______,	_______,	_______
),

/* SUPRA75
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |
 * |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+-----------------|
 * |                                                                                                           |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                             4x12 SUPRA LAYOUT                                             |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[SUP75] = LAYOUT_ortho_5x15_wrapper(
  _________________BLANK_75__________________,
  ________________SUPRA_Row_0________________, _______, _______, _______,
  ________________SUPRA_Row_1________________, _______, _______, _______,
  ________________SUPRA_Row_2________________, _______, _______, _______,
  _________________BLANK_75__________________
),

/* Gherkin 75 Numbers
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |
 * |-----------------------------------------------------------------------------------------------------------|--------+-----------------|
 * |                                                                                                           |   /    |   *    |   -    |
 * |                                                                                                           |--------+--------+--------|
 * |                                            4x12 NUMBERS LAYOUT                                            |        |        |   +    |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        | ENTER  |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[NUM75] = LAYOUT_ortho_5x15_wrapper(
  _________________BLANK_75__________________,
  _______________NUMBERS_Row_0_______________, KC_PSLS, KC_PAST, KC_PMNS,
  _______________NUMBERS_Row_1_______________, _______, _______, KC_PPLS,
  _______________NUMBERS_Row_2_______________, _______, _______, KC_PENT,
  _______________NUMBERS_Row_3_______________, _______, _______, _______
),

/* Gherkin 75 Et Cetera
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |
 * |-----------------------------------------------------------------------------------------------------------|--------+-----------------|
 * |                                                                                                           |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                           4x12 ETCETERA LAYOUT                                            |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[ETC75] = LAYOUT_ortho_5x15_wrapper(
  _________________BLANK_75__________________,
  ______________ETCETERA_Row__0______________, _______, _______, _______,
  ______________ETCETERA_Row__1______________, _______, _______, _______,
  ______________ETCETERA_Row__2______________, _______, _______, _______,
  ______________ETCETERA_Row__3______________, _______, _______, _______
),

/* Gherkin 75 Directional Keys
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |
 * |-----------------------------------------------------------------------------------------------------------|--------+-----------------|
 * |                                                                                                           |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                          4x12 DIRECTIONAL LAYOUT                                          |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * |                                                                                                           |--------+--------+--------|
 * |                                                                                                           |        |        |        |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[DIR75] = LAYOUT_ortho_5x15_wrapper(
  _________________BLANK_75__________________,
  _____________DIRECTIONS_Row__0_____________, _______, _______, _______,
  _____________DIRECTIONS_Row__1_____________, _______, _______, _______,
  _____________DIRECTIONS_Row__2_____________, _______, _______, _______,
  _______, _______, QWERTY75,  _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______, _______
),


/* FUNCTION 75
 * .--------------------------------------------------------------------------------------------------------------------------------------.
 * |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |
 * |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+-----------------|
 * |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |
 * |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
 * | CAP LK | MS BT5 | MS BT4 | MS BT3 | MS BT2 | SLOW M | FAST M | NEXT   | VOL+   | VOL-   | PLAY   |        |        |        | WHEEL+ |
 * |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
 * | RGB TG | RGB MD | RGB HI | RGB HD | RGB SI | RGB SD | RGB VI | RGB VD | BL TOG | BL INC | BL DEC |        |        | MOUS U | WHEEL- |
 * |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
 * |        |        |        |        |        |        | MS BT1 |        |        |        |        |        | MOUS L | MOUS D | MOUS R |
 * '--------------------------------------------------------------------------------------------------------------------------------------'
 */
[FN75] = LAYOUT_ortho_5x15_wrapper(
  _________________BLANK_75__________________,
  _________________BLANK_75__________________,
  KC_CAPS, KC_BTN5, KC_BTN4, KC_BTN3, KC_BTN2, KC_ACL0, KC_ACL2, KC_MNXT, KC_VOLD, KC_VOLU, KC_MPLY, _______, _______, _______, KC_WH_U,
  RGB_TOG, RGB_MOD, RGB_HUI, RGB_HUD, RGB_SAI, RGB_SAD, RGB_VAI, RGB_VAD, BL_TOGG, BL_INC,  BL_DEC,  _______, _______, KC_MS_U, KC_WH_D,
  _______, _______, _______, _______, _______, _______, KC_BTN1, _______, _______, _______, _______, _______, KC_MS_L, KC_MS_D, KC_MS_R
),

[gNUM] = LAYOUT_ortho_5x10_wrapper(
  _________________BLANK_50__________________,
  _______________Gherkin_NUM_0_______________,
  _______________Gherkin_NUM_1_______________,
  _______________Gherkin_NUM_2_______________,
  _______, _______, _______, _______, _______, KC_ENT, KC_RSFT, KC_RGUI, _______, _______
),

[gDIR] = LAYOUT_ortho_5x10_wrapper(
  _________________BLANK_50__________________,
  _______________Gherkin_DIR_0_______________,
  _______________Gherkin_DIR_1_______________,
  _______________Gherkin_DIR_2_______________,
  _________________BLANK_50__________________
),

[gETC] = LAYOUT_ortho_5x10_wrapper(
  _________________BLANK_50__________________,
  _______________Gherkin_ETC_0_______________,
  _______________Gherkin_ETC_1_______________,
  _______________Gherkin_ETC_2_______________,
  _______, KC_CAPS, _______, _______, _______, LALT(LCTL(KC_DEL)), _______, _______, _______, _______
),
};
